//=============================================================================
// MUT_SetGameType
//
// Author: }TCP{Wolf
// Date: 2008-03-29
//
// This is a very simple mutator which sets the GameType of your server to
// whatever you like. This allows you to have your server appear in the
// clients browser on a different TAB than it normally would.
//=============================================================================

class MUT_SetGameType extends Mutator;

// preferences
var() config enum SearchStringMatch_TYPE	// WHEN to set
{
	always,		// always set
	partial,	// set if partial match (InStr (CAPS(..) ....)) case-IN-sensitive
	precise		// set if PRECISE match ( == )
} SearchStringMatch;

var() config float StartupWaitTime;	// number of seconds to wait before doing action

var() config String SearchString;	// what String to look for in the original GameType
var() config String SetToGameType;	// what String to set the GameType to


// startup state: all it does is wait before doing action
auto state init
{
	Begin:
		Sleep(StartupWaitTime);
		DoYourThingy();
}


// convenience log function
function l(String what)
{
	log(what,'MUT_SetGameType');
}


// this is where the action of setting the game type takes place
function DoYourThingy()
{
	local String old;
	local bool bDoSet;

	old = Level.Game.GameName;
	l("Old GameType String: "$old);

	// determine if the GameType being advertised should be changed
	switch(SearchStringMatch)
	{
		case always:	// this one is simple, YES it should be changed
			bDoSet = true;
			break;

		case partial:	// insensitive partial search
			bDoSet = (   (InStr( CAPS(old) , CAPS(SearchString) )) > -1   );
			break;

		case precise:
			bDoSet = (SearchString == old);	// yes if equality
			break;

		default:
			bDoSet = false;
	}

	// do action now or not?
	if (bDoSet)	// yes
	{
		l("Changing GameType to "$SetToGameType);
		Level.Game.GameName = SetToGameType;
	}
	else	// no
		l("GameType not changed.");
}



defaultproperties
{
	SearchStringMatch=always
	StartupWaitTime=1.5
	SetToGameType="My Custom GameType"
}
